<?php

/*------------------------------------------------------------------------
# com_invoices - Invoice Manager for Joomla
# ------------------------------------------------------------------------
# author				Germinal Camps
# copyright 			Copyright (C) 2014 JoomlaThat.com. All Rights Reserved.
# @license				http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: 			http://www.JoomlaThat.com
# Technical Support:	Forum - http://www.JoomlaThat.com/support
-------------------------------------------------------------------------*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

//new for Joomla 3.0
if(!defined('DS')){
define('DS',DIRECTORY_SEPARATOR);
}

class  plgAkeebasubsInvoicemanager extends JPlugin
{
	

	function plgAkeebasubsInvoicemanager(& $subject, $config)
	{
		
		$lang = JFactory::getLanguage();
		$lang->load('com_invoices', JPATH_SITE);
		
		parent::__construct($subject, $config);

	}
	
	function onAKSubscriptionChange($row, $info) {
		
		if(in_array($row->state, array('C'))) {
			$this->create_invoice($row);
		}
		
		return true;
	}

	
	function create_invoice($data){

		require_once(JPATH_SITE.DS.'components'.DS.'com_invoices'.DS.'helpers'.DS.'helpers.php');
		//print_r($data);die;
		$db = JFactory::getDBO();

		$component = "com_akeebasubs" ;

		//we check if this particular order had already been tracked
		$query = " SELECT id FROM #__invoices_invoices WHERE external_type = '".$component."' AND external_id = ".$data->akeebasubs_subscription_id;
		$db->setQuery($query);
		$exists = $db->loadResult();

		//if it didn't exist, we attemp to create the conversion
		if(!$exists){

			$params = JComponentHelper::getParams( 'com_invoices' );

			$query = ' SELECT i.real_invoice_num FROM #__invoices_invoices as i WHERE i.type = 1 '.
					 ' ORDER BY i.id DESC ';
			$db->setQuery( $query );
			$real_invoice_num = $db->loadResult() + 1;
			$invoice_num = InvoicesHelper::getInvoiceNum($real_invoice_num) ;

			$query = " SELECT ake.*, u.name, u.email FROM #__akeebasubs_users AS ake LEFT JOIN #__users AS u ON u.id = ake.user_id WHERE ake.user_id = ".$data->user_id;
			$db->setQuery($query);
			$user = $db->loadObject();

			$taxes = array();

			$invoice_data = array(	
								"to_name" => $user->name ,
								"to_company" => $user->businessname,
								"to_address" => $user->address1 . "\n" . $user->address2,
								"to_email" => $user->email,
								"to_zipcode" => $user->zip,
								"to_city" => $user->city,
								"to_state" => $user->state,
								"to_country" => $user->country,
								"to_phone" => "",
								"to_vatid" => $user->vatnumber,
								"vincular_cliente_checkbox" => 2,
								"from_name" => $params->get('from_name'),
								"from_address" => $params->get('from_address'),
								"from_num" => $params->get('from_num'),
								"from_url" => $params->get('from_url'),
								"from_email" => $params->get('from_email'),
								"from_phone" => $params->get('from_phone'),
								"invoice_num" => $invoice_num,
								"real_invoice_num" => $real_invoice_num,
								"invoice_date" => date('Y-m-d H:i:s'),
								"template_id" => $params->get('invoice_template'),
								"currency_before" => $params->get('currency_before'),
								"currency_after" => $params->get('currency_after'),
								"publish" => $this->params->get('activation'),
								"start_publish" => "",
								"end_publish" => "",
								"joomla_user_id" => $data->user_id,
								"taxes" => $taxes,
								"status" => 'paid',
								"external_type" => $component,
								"external_id" => $data->akeebasubs_subscription_id
								) ;
			
			$items = array();

			$query = " SELECT title FROM #__akeebasubs_levels WHERE akeebasubs_level_id = ".$data->akeebasubs_level_id;
			$db->setQuery($query);
			$title = $db->loadResult();

			$tax = ( $data->tax_amount / $data->net_amount ) * 100 ;

			$items[] = array(
								"sku" => $data->plan_id,
								"name" => $title,
								"desc" => $title,
								"value" => $data->net_amount,
								"amount" => 1,
								"tax" => $tax,
								"external_type" => $component,
								"product_id" => $data->akeebasubs_level_id,
								);

			$payments = array();
			$payments[0] = array(
								"id" => 0,
								"payment_details" => "",
								"payment_datetime" => date('Y-m-d H:i:s'),
								"payment_amount" => $data->gross_amount,
								"payment_type" => $data->processor,
								"payment_description" => "Payment",
								"payment_id" => $data->processor_key,
								"payment_status" => 1
								);
							
			InvoicesHelper::create_invoice($invoice_data, $items, $payments);

		}
	}
	
}


